org.apache.commons.math3.distribution

## Class UniformIntegerDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractIntegerDistribution
  - - org.apache.commons.math3.distribution.UniformIntegerDistribution

- All Implemented Interfaces:
    Serializable, IntegerDistribution

      public class UniformIntegerDistribution
      extends AbstractIntegerDistribution

  Implementation of the uniform integer distribution.
  Since:
    3.0
  Version:
    $Id: UniformIntegerDistribution.java 1244107 2012-02-14 16:17:55Z erans $
  See Also:
    Uniform distribution (discrete), at Wikipedia, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `randomData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UniformIntegerDistribution(int lower, int upper)` Creates a new uniform integer distribution using the given lower and upper bounds (both inclusive).

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `int` | `getSupportLowerBound()` Access the lower bound of the support.
    `int` | `getSupportUpperBound()` Access the upper bound of the support.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `double` | `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.
    `int` | `sample()` Generate a random value sampled from this distribution.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, solveInverseCumulativeProbability`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UniformIntegerDistribution

          public UniformIntegerDistribution(int lower,
                                    int upper)
                                     throws NumberIsTooLargeException

      Creates a new uniform integer distribution using the given lower and upper bounds (both inclusive).
      Parameters:
        `lower` - Lower bound (inclusive) of this distribution.
        `upper` - Upper bound (inclusive) of this distribution.
      Throws:
        `NumberIsTooLargeException` - if `lower >= upper`.

  - ### Method Detail

    - #### probability

          public double probability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.
      Parameters:
        `x` - the point at which the PMF is evaluated
      Returns:
        the value of the probability mass function at `x`

    - #### cumulativeProbability

          public double cumulativeProbability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. For lower bound `lower` and upper bound `upper`, the mean is `0.5 * (lower + upper)`.
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. For lower bound `lower` and upper bound `upper`, and `n = upper - lower + 1`, the variance is `(n^2 - 1) / 12`.
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

    - #### getSupportLowerBound

          public int getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in Z | P(X <= x) > 0}`.

      The lower bound of the support is equal to the lower bound parameter of the distribution.
      Returns:
        lower bound of the support

    - #### getSupportUpperBound

          public int getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is equal to the upper bound parameter of the distribution.
      Returns:
        upper bound of the support

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

    - #### sample

          public int sample()

      Generate a random value sampled from this distribution. The default implementation uses the inversion method.
      Specified by:
        `sample` in interface `IntegerDistribution`
      Overrides:
        `sample` in class `AbstractIntegerDistribution`
      Returns:
        a random value

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.